var us = require('underscore'),
    sendError;

module.exports.sendError = sendError = function sendError(flowId, name, message, body, status, res) {
    var err = {
        flowId: flowId,
        name: name,
        message: message,
        body: body
    };

    if (res) {
        res.status(status).send(err);
    }
    else {
        //TODO: Better handle this with logs and whatnot
        console.error(JSON.stringify(err,null,2));
    }
};

//common.setReady(activity, flowDoc.activities);
module.exports.setReady = function setReady(state, activity, activities) {
    var goto, j, candidateActivity;

    for (var i=0; i<activity.gotos.length; i++) {
        goto = activity.gotos[i];

        // TODO: Evaluate condition, assume true for now.
        if (goto.state == state) {
            for (j=0; j<activities.length; j++) {
                candidateActivity = activities[j];

                if (candidateActivity.activityId == goto.targetActivityId) {
                    candidateActivity.state = 'ready';

                    if (state == 'failed') {
                        activity.state = 'dirty';
                    }

                }
            }
        }
    }
};

module.exports.findActivity = function findActivity(FlowsModel, flowId, activityId, res, callback) {
    var activity;

    FlowsModel.findById (
        flowId,
        function(err, flowDoc) {
            if (err) {

                callback(
                    {
                        name: 'activityFinishFail',
                        message: 'Unable to update finished activity',
                        body: err,
                        status: 500
                    }
                );

            }
            else {

                if (flowDoc) {

                    activity = flowDoc.findActivity(activityId);

                    if (activity) {
                        callback(null, flowDoc, activity);
                    }

                    else {

                        callback(
                            {
                                name: 'unknownActivity',
                                message: "Unable to find activity '"+ activityId +"'",
                                body: err,
                                status: 404
                            }
                        );

                    }
                }
                else
                {

                    callback(
                        {
                            name: 'unknownFlow',
                            message: "Unable to find flow",
                            body: err,
                            status: 404
                        }
                    );


                }

            }

        }

    );
};

