var sendError = require('./common').sendError,
    us = require('underscore');


module.exports = function(roadie) {

    var FlowsModel = null;

    return function getActivity(req, res) {

        var flowId = req.params.flowId,
            activityId,
            activity,
            toSend,
            activityData;

        if (!FlowsModel) {
            FlowsModel = roadie.db.model('_sys.flow.1.0.flows');
        }

        FlowsModel.findById(
            flowId,
            function(err, flowDoc) {
                if (err) {
                    res.status(500).send(err);
                }
                else {
                    if (flowDoc) {
                        activityId = req.params.activityId;
                        activity = flowDoc.findActivity(activityId);

                        if (activity) {


                            toSend = {
                                id: activity.activityId,
                                flowId: flowId,
                                state: activity.state,
                                data: activity.data,
                                type: activity.activityType,
                                typeConfig: roadie.activities[activity.activityType].properties,
                                audience: activity.audience,
                                activityConfig: activity.config,
                                flow: {
                                    id: flowDoc._id,
                                    templateId: flowDoc.templateId,
                                    state: flowDoc.state,
                                    namespace: flowDoc.namespace,
                                    blueprintName: flowDoc.blueprintName,
                                    blueprintVersion: flowDoc.blueprintVersion,
                                    blueprintLocalVersion: flowDoc.blueprintLocalVersion
                                    // createdBy: flowDoc.createdBy
                                },
                                lastStarted: activity.lastStarted,
                                lastCompleted: activity.lastCompleted,
                                messages: activity.messages
                            };

                            res.status(200).send(toSend);
                        }
                        else {
                            sendError(
                                flowDoc._id,
                                'noActivity',
                                'Flow ' + flowDoc._id + " has no start activity '"+ activityId +"'",
                                null,
                                404,
                                res
                            );
                        }

                    }
                    else {

                        sendError(
                            flowId,
                            'noFlow',
                            "Unable to find flow '" + flowId + "'",
                            null,
                            404,
                            res
                        );
                    }
                }
            }
        );



    }

};