var us = require('underscore');



// states = ['pristine', 'running', 'pending', 'ready', 'failed', 'finished'];

function explicitlyIncluded(key, includes) {

    var match;

    if (includes) {

        if (us.isString(includes)) {
            match = key == includes;
        }
        else if (us.isArray(includes)) {
            match = includes.indexOf(key) > -1;
        }
        else {
            match = false;
        }

    }
    else {
        match = false;
    }

    return match;
}

module.exports = function runGrabBlueprintData(activity, context, callback) {




    var targetActivity,
        params = {
            ns: context.flowDoc.namespace,
            bp: context.flowDoc.blueprintName,
            model: context.flowDoc.params.sourceSchema,
            docId: context.flowDoc.params.sourceDocId
        };


    if (us.has(activity.config, 'targetActivityId')) {

        targetActivity = context.flowDoc.findActivity(activity.config.targetActivityId);

            //context.flowDoc.activities[activity.config.targetActivityId];
    }
    else {
        targetActivity = activity;
    }


    //
    // roadie, params, query, callback
    context.roadie.data.getDoc(
        context.roadie,
        params,
        {},
        function(err, doc) {

            if (err) {
                console.error(err);
                activity.state = 'failed';
                activity.activityMessages.push(
                    {
                        level: 'error',
                        name: err.name,
                        message: err.message,
                        body: err
                    }
                );

                callback(null, activity);
            }
            else {


                if (!us.isObject(targetActivity.data)) {
                    targetActivity.data = {};
                }


                for (var key in doc) {
                    if (doc.hasOwnProperty(key)) {
                        if (key[0] != '_' || explicitlyIncluded(key, activity.config.include)) {
                            targetActivity.data[key] = doc[key];
                        }

                    }
                }

                activity.state = 'finished';
                callback(null, activity);
            }
        }
    );


};
