
var async = require('async');

module.exports = function grabListFunction (roadie, key, params, callback) {

    var lists = {},
        ListModel = roadie.db.model('_sys.data.1.0.lists');

    async.each(
        params.listIds,
        function (listId, cb) {

            ListModel.findOne(
                {
                    namespace: params.namespace,
                    blueprintName: params.blueprintName,
                    installedFromBlueprintVersion: params.blueprintVersion,
                    installedFromBlueprintLocalVersion: params.blueprintLocalVersion,
                    listName: listId
                },
                "list",
                {lean: true},
                function (err, list) {

                    if (err) {
                        cb(err);
                    }
                    else {
                        lists[listId] = list.list;
                        cb();
                    }
                }
            );

        },
        function (err) {
            if (err) {
                callback(err);
            }
            else {
                callback(null, lists);
            }
        }
    );

};
