var us = require('underscore');

// states = ['pristine', 'running', 'pending', 'ready', 'failed', 'finished'];


module.exports = function runGrabLists(activity, context, callback) {

    var listSetKey = [
        context.flowDoc.namespace,
        context.flowDoc.blueprintName,
        context.flowDoc.blueprintVersion,
        context.flowDoc.blueprintLocalVersion,
        activity.activityId
    ].join('.');

    context.roadie.cache.get(
        'listSets',
        listSetKey,
        {
            namespace: context.flowDoc.namespace,
            blueprintName: context.flowDoc.blueprintName,
            blueprintVersion: context.flowDoc.blueprintVersion,
            blueprintLocalVersion: context.flowDoc.blueprintLocalVersion,
            listIds: activity.config.listIds
        },
        function (err, lists) {

            if (err) {
                console.error(err);
                activity.state = 'failed';
                activity.activityMessages.push(
                    {
                        level: 'error',
                        name: err.name,
                        message: err.message,
                        body: err
                    }
                );
            }
            else {
                var targetActivity;
                if (us.has(activity.config, 'targetActivityId')) {
                    targetActivity = context.flowDoc.findActivity(activity.config.targetActivityId);
                }
                else {
                    targetActivity = activity;
                }

                if (!us.isObject(targetActivity.data)) {

                    targetActivity.data = {};
                }

                targetActivity.data._$lists = lists;

                activity.state = 'finished';
                callback(null, activity);

            }

        }
    );




};
