
// DEFAULTS ARE USED IN ROADIEJS-HOME AS WELL!

var us = require('underscore');


// states = ['pristine', 'running', 'pending', 'ready', 'failed', 'finished'];

var funcs = {

    "TODAY": function() {
        var today = new Date();
        today.setHours(0);
        today.setMinutes(0);
        today.setMilliseconds(0);
        return today;
    },


    "NOW": function() {
        return new Date();
    },


    "DATE": function(dateString) {
        var date = new Date(dateString);
        return date;
    }
};

function expand(def) {

    var ready, argString;

    if (us.isString(def)) {

        var match = def.match(/^\[\[(.*?)]]/);
        if (match) {


            var functionName = match[1];
            if (functionName.slice(-1) == ')') {
                var start = functionName.indexOf('(');
                if (start != -1) {
                    argString = functionName.substring(start);
                    argString = argString.substring(1); // remove first '('
                    argString = argString.slice(0, - 1); // remove last ')'
                    functionName = functionName.substring(0, start);
                }
            }

            var defaultFunction = funcs[functionName];

            if (defaultFunction) {
                ready = defaultFunction(argString);
            }
            else {
                ready = def; // Unknown default function, so assume it's a weird literal.
            }

        }
        else {

            ready = def; // A string literal

        }

    }
    else {

        ready = def; // A numeric literal or similar?
    }
    return ready;
}

module.exports = function runSetDefaults(activity, context, callback) {

    var targetActivity = context.flowDoc.findActivity(activity.config.targetActivityId);

    if (!us.isObject(targetActivity.data)) {
        targetActivity.data = {};
    }


    var defaults = activity.config.defaults, def;

    for (var path in defaults) {

        if (defaults.hasOwnProperty(path)) {
            def = activity.config.defaults[path];
            targetActivity.data[path] = expand(def);
        }

    }

    activity.state = 'finished';
    callback(null, activity);


};

