module.exports.uploadFunction = function (
    roadie,
    rawElement,
    namespace,
    blueprintName,
    blueprintVersion,
    localVersion,
    rawElements,
    elementTypes,
    logger,
    errors) {

    return function categoryUpload(restructured, callback) {


        if ( namespace=='_sys' && blueprintName == 'flow') {

            // We'll add the flow categories for making flows later via a System-blueprint
            // so moving on...
            callback(null, restructured);
        }

        else {

            var Categories = roadie.db.model('_sys.flow.1.0.categories'),
                self = this;


            Categories.findOne({categoryId: rawElement.id}, function(err, doc) {

                if (err) {
                    errors.push(
                        {
                            name:'categoryUploadFail1',
                            message: "Problem finding category via ID",
                            body: JSON.stringify(err)
                        }
                    );
                    callback(null, restructured);
                }
                else {

                    if (doc) {

                        // Category already exists so just move on... first installed wins.
                        callback(null, restructured);
                    }

                    else {

                        var modelRunner = roadie.data.runners.model;

                        modelRunner(
                            roadie,
                            'post',
                            {
                                ns: '_sys',
                                bp: 'flow',
                                model: 'categories'
                            }, // params
                            {}, // query
                            {
                                categoryId: rawElement.id,
                                label: rawElement.config.label,
                                description: rawElement.config.description,
                                less: rawElement.config.less,
                                namespace: namespace,
                                blueprintName: blueprintName,
                                blueprintVersion: blueprintVersion,
                                blueprintLocalVersion: localVersion
                            }, // body
                            roadie.data.actionFunctions.post,

                            function(err) {
                                if (err) {

                                    errors.push(
                                        {
                                            name:'categoryUploadFail2',
                                            message: "Problem saving category via ID",
                                            body: JSON.stringify(err)
                                        }
                                    );
                                    callback(null, restructured);

                                }
                                else {
                                    callback(null, restructured);
                                }
                            }
                        );
                    }
                }
            });

        }

    }
};
