var makeTemplateActivities = require('./../elements/flow/uploadFunction').makeTemplateActivities;

module.exports = function ensureTemplatesFlow(roadie, callback) {

    var blueprint = roadie.getBlueprintElement(
        '_sys.flow.1.0',
        'maintainCategory',
        function (err, element) {

            if (err) {
                callback(err);

            }

            else {

                var flowId = '_sys.flow.maintainCategory',
                    Templates = roadie.db.model('_sys.flow.1.0.templates');

                Templates.findOneAndRemove({templateId: flowId}, function(err) {
                    if (err) {

                        callback(err);

                    }
                    else {

                        var modelRunner = roadie.data.runners.model;
                        var templateActivities = makeTemplateActivities(element);

                        modelRunner(
                            roadie,
                            'post',
                            {
                                ns: '_sys',
                                bp: 'flow',
                                model: 'templates'
                            }, // params
                            {}, // query
                            {
                                templateId: flowId,
                                namespace: '_sys',
                                blueprintName: 'flow',
                                blueprintVersion: 1,
                                blueprintLocalVersion: 0,
                                name: element._id,
                                category: element.category,
                                label: element.label,
                                description: element.description,
                                templateActivities: templateActivities,
                                instigators: element.instigators
                            }, // body
                            roadie.data.actionFunctions.post,
                            callback
                        );


                    }
                });



            }
        }

    );


};