
module.exports = function ensureSystemCategories(roadie, callback) {

    var blueprint = roadie.getBlueprintElement(
        '_sys.flow.1.0',
        'system',
        function (err, element) {

            if (err) {

                callback(err);

            }


            else {

                var categoryId = 'system',
                    Categories = roadie.db.model('_sys.flow.1.0.categories');

                Categories.findOneAndRemove({categoryId: categoryId}, function(err) {
                    if (err) {
                        callback(err);

                    }
                    else {

                        var modelRunner = roadie.data.runners.model;

                        modelRunner(
                            roadie,
                            'post',
                            {
                                ns: '_sys',
                                bp: 'flow',
                                model: 'categories'
                            }, // params
                            {}, // query
                            {
                                categoryId: categoryId,
                                label: element.label,
                                description: element.description,
                                less: element.less,
                                namespace: '_sys',
                                blueprintName: 'flow',
                                blueprintVersion: 1,
                                blueprintLocalVersion: 0
                            },

                            roadie.data.actionFunctions.post,
                            callback
                        );


                    }
                });

            }
        }

    );


};