

module.exports = function generateRoutes(roadie) {
    var addMiniCrudRoutes = require('roadiejs-api').addMiniCrudRoutes,
        actions = require('./actions')(roadie),
        path;

    roadie.addDomain('flows', 'Flows');
    roadie.addDomainRoute('flows', 'get', '/:flowId/:activityId', {doc: 'Get info about live flows'}, actions.getActivity);

    roadie.addDomainRoute('flows', 'post', '', {doc: 'Create a new flow'}, actions.createFlowFromRequest);
    roadie.addDomainRoute('flows', 'delete', '/:flowId', {doc: 'Stop a current flow'}, actions.stopFlowFromRequest);

    roadie.addDomainRoute('flows', 'put', '/:flowId/:activityId/data', {doc: "Set an activity's data and progress the flow"}, actions.setDataAndProgress);


    roadie.logger.debug('     Routes:');
    roadie.logger.debug('      flows:');
    roadie.publishRoutes('flows');
    roadie.logger.debug('      renderer:');
    roadie.publishRoutes('renderer');

};